/// @see IME/ImeConfig.cpp
/// @see dlgkeybind.cpp

/// [\Lp
struct TSkkBaseRule {
	BYTE nRule;			///< [ԍ (2bit)
	BYTE nNext;			///< [ԍ (2bit)
	WORD nFunc;			///< R}hԍ (8bit)(ol肳邽ߎ4bitx)
	LPCSTR szRule;		///< Ώۃp^[ (4bit)(͎2`3bitx)
	LPCSTR szNext;		///< Ɉpp^[ (4bit)
	LPCWSTR wszOut;		///< Ђ炪 / L (4bit)
	LPCWSTR wszKata;	///< J^Ji (4bit)
	LPCWSTR wszKana;	///< pJ^Ji (4bit)  v32bit
};

/// [}ȕϊ[ 
/**
@todo [hI[XL݂̗̂pȂ̂ŁAϒ\
ă|C^rׂBڍs̎肪ɑSe[u{iKB
(RuleTreeNode.cppȂ)ł͍ő32xz肵ĂH
le[u7`15Ώ\ƏɔfɊւ
obt@16oCgŏĂB֘A͕ϐŌB

uavƃRgĂs̃[́AlIϓ_炷ƕ\
LƔ{̎ƍĂ炸AقƂǗp邱Ƃ
̂ƎvB͍폜ɑɍ킹ق
ȂA̓{̔LxɂȂ邱ƂzĎc
܂܂ł悢ȂAǂ炢̂܂킩ȂB
*/
static struct TSkkBaseRule _rDefaultRomaKanaRule[] = {
	// 
	{ 0, 0, 0,	"a",	NULL,	L"",		L"A",		L"" },
	{ 0, 0, 0,	"i",	NULL,	L"",		L"C",		L"" },
	{ 0, 0, 0,	"u",	NULL,	L"",		L"E",		L"" },
	{ 0, 0, 0,	"e",	NULL,	L"",		L"G",		L"" },
	{ 0, 1, 0,	"o",	NULL,	L"",		L"I",		L"" },

	{ 0, 0, 0,	"ka",	NULL,	L"",		L"J",		L"" },
	{ 0, 0, 0,	"ki",	NULL,	L"",		L"L",		L"" },
	{ 0, 0, 0,	"ku",	NULL,	L"",		L"N",		L"" },
	{ 0, 0, 0,	"ke",	NULL,	L"",		L"P",		L"" },
	{ 0, 0, 0,	"ko",	NULL,	L"",		L"R",		L"" },

	{ 0, 0, 0,	"sa",	NULL,	L"",		L"T",		L"" },
	{ 0, 0, 0,	"si",	NULL,	L"",		L"V",		L"" },
	{ 0, 0, 0,	"su",	NULL,	L"",		L"X",		L"" },
	{ 0, 0, 0,	"se",	NULL,	L"",		L"Z",		L"" },
	{ 0, 0, 0,	"so",	NULL,	L"",		L"\",		L"" },

	{ 0, 0, 0,	"ta",	NULL,	L"",		L"^",		L"" },
	{ 0, 0, 0,	"ti",	NULL,	L"",		L"`",		L"" },
	{ 0, 0, 0,	"tu",	NULL,	L"",		L"c",		L"" },
	{ 0, 0, 0,	"te",	NULL,	L"",		L"e",		L"" },
	{ 0, 0, 0,	"to",	NULL,	L"",		L"g",		L"" },

	{ 0, 0, 0,	"na",	NULL,	L"",		L"i",		L"" },
	{ 0, 0, 0,	"ni",	NULL,	L"",		L"j",		L"" },
	{ 0, 0, 0,	"nu",	NULL,	L"",		L"k",		L"" },
	{ 0, 0, 0,	"ne",	NULL,	L"",		L"l",		L"" },
	{ 0, 0, 0,	"no",	NULL,	L"",		L"m",		L"" },

	{ 0, 0, 0,	"ha",	NULL,	L"",		L"n",		L"" },
	{ 0, 0, 0,	"hi",	NULL,	L"",		L"q",		L"" },
	{ 0, 0, 0,	"hu",	NULL,	L"",		L"t",		L"" },
	{ 0, 0, 0,	"he",	NULL,	L"",		L"w",		L"" },
	{ 0, 0, 0,	"ho",	NULL,	L"",		L"z",		L"" },

	{ 0, 0, 0,	"ma",	NULL,	L"",		L"}",		L"" },
	{ 0, 0, 0,	"mi",	NULL,	L"",		L"~",		L"" },
	{ 0, 0, 0,	"mu",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"me",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"mo",	NULL,	L"",		L"",		L"" },

	{ 0, 0, 0,	"ya",	NULL,	L"",		L"",		L"" },
#ifndef SKK_FUNDAMENTALISM
	{ 0, 0, 0,	"yi",	NULL,	L"",		L"C",		L"" },	// corrupted-consonantɕKv
#endif
	{ 0, 0, 0,	"yu",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"ye",	NULL,	L"",	L"CF",	L"" },
	{ 0, 0, 0,	"yo",	NULL,	L"",		L"",		L"" },

	{ 0, 0, 0,	"ra",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"ri",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"ru",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"re",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"ro",	NULL,	L"",		L"",		L"" },

	{ 0, 0, 0,	"wa",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"wi",	NULL,	L"",	L"EB",	L"" },
	{ 0, 0, 0,	"wu",	NULL,	L"",		L"E",		L"" },
	{ 0, 0, 0,	"we",	NULL,	L"",	L"EF",	L"" },
	{ 0, 0, 0,	"wo",	NULL,	L"",		L"",		L"" },

	{ 0, 0, 0,	"ga",	NULL,	L"",		L"K",		L"" },
	{ 0, 0, 0,	"gi",	NULL,	L"",		L"M",		L"" },
	{ 0, 0, 0,	"gu",	NULL,	L"",		L"O",		L"" },
	{ 0, 0, 0,	"ge",	NULL,	L"",		L"Q",		L"" },
	{ 0, 0, 0,	"go",	NULL,	L"",		L"S",		L"" },

	{ 0, 0, 0,	"za",	NULL,	L"",		L"U",		L"" },
	{ 0, 0, 0,	"zi",	NULL,	L"",		L"W",		L"" },
	{ 0, 0, 0,	"zu",	NULL,	L"",		L"Y",		L"" },
	{ 0, 0, 0,	"ze",	NULL,	L"",		L"[",		L"" },
	{ 0, 0, 0,	"zo",	NULL,	L"",		L"]",		L"" },

	{ 0, 0, 0,	"da",	NULL,	L"",		L"_",		L"" },
	{ 0, 0, 0,	"di",	NULL,	L"",		L"a",		L"" },
	{ 0, 0, 0,	"du",	NULL,	L"",		L"d",		L"" },
	{ 0, 0, 0,	"de",	NULL,	L"",		L"f",		L"" },
	{ 0, 0, 0,	"do",	NULL,	L"",		L"h",		L"" },

	{ 0, 0, 0,	"ba",	NULL,	L"",		L"o",		L"" },
	{ 0, 0, 0,	"bi",	NULL,	L"",		L"r",		L"" },
	{ 0, 0, 0,	"bu",	NULL,	L"",		L"u",		L"" },
	{ 0, 0, 0,	"be",	NULL,	L"",		L"x",		L"" },
	{ 0, 0, 0,	"bo",	NULL,	L"",		L"{",		L"" },

	{ 0, 0, 0,	"pa",	NULL,	L"",		L"p",		L"" },
	{ 0, 0, 0,	"pi",	NULL,	L"",		L"s",		L"" },
	{ 0, 0, 0,	"pu",	NULL,	L"",		L"v",		L"" },
	{ 0, 0, 0,	"pe",	NULL,	L"",		L"y",		L"" },
	{ 0, 0, 0,	"po",	NULL,	L"",		L"|",		L"" },

	// 
	{ 0, 0, 0,	"n",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"n'",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"nn",	NULL,	L"",		L"",		L"" },

	// P
	{ 0, 0, 0,	"xa",	NULL,	L"",		L"@",		L"" },
	{ 0, 0, 0,	"xi",	NULL,	L"",		L"B",		L"" },
	{ 0, 0, 0,	"xu",	NULL,	L"",		L"D",		L"" },
	{ 0, 0, 0,	"xe",	NULL,	L"",		L"F",		L"" },
	{ 0, 0, 0,	"xo",	NULL,	L"",		L"H",		L"" },

#ifdef SKK_FUNDAMENTALISM
	{ 0, 0, 0,	"xka",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xke",	NULL,	L"",		L"",		L"" },

	{ 0, 0, 0,	"xtu",	NULL,	L"",		L"b",		L"" },

	{ 0, 0, 0,	"xtsu", NULL,	L"",		L"b",		L"" },

	{ 0, 0, 0,	"xwa",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xwi",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xwe",	NULL,	L"",		L"",		L"" },

	{ 0, 0, 0,	"xya",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xyu",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xyo",	NULL,	L"",		L"",		L"" },
#else
	{ 0, 0, 0,	"xka",	NULL,	L"",	L"",		L"" },
	{ 0, 0, 0,	"xki",	NULL,	L"",	L"bL",	L"" },
	{ 0, 0, 0,	"xku",	NULL,	L"",	L"bN",	L"" },
	{ 0, 0, 0,	"xke",	NULL,	L"",	L"",		L"" },	// a(啶)  
	{ 0, 0, 0,	"xko",	NULL,	L"",	L"bR",	L"" },

	{ 0, 0, 0,	"xta",	NULL,	L"",	L"b^",	L"" },
	{ 0, 0, 0,	"xti",	NULL,	L"",	L"b`",	L"" },
	{ 0, 0, 0,	"xtu",	NULL,	L"",		L"b",		L"" },
	{ 0, 0, 0,	"xte",	NULL,	L"",	L"be",	L"" },
	{ 0, 0, 0,	"xto",	NULL,	L"",	L"bg",	L"" },

	{ 0, 0, 0,	"xtsa", NULL,	L"",	L"b@",	L"" },
	{ 0, 0, 0,	"xtsi", NULL,	L"",	L"bB",	L"" },
	{ 0, 0, 0,	"xtsu", NULL,	L"",		L"b",		L"" },
	{ 0, 0, 0,	"xtse", NULL,	L"",	L"bF",	L"" },
	{ 0, 0, 0,	"xtso", NULL,	L"",	L"bH",	L"" },

	{ 0, 0, 0,	"xwa",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xwi",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xwu",	NULL,	L"",		L"D",		L"" },
	{ 0, 0, 0,	"xwe",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xwo",	NULL,	L"",		L"H",		L"" },

	{ 0, 0, 0,	"xya",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xyi",	NULL,	L"",		L"B",		L"" },
	{ 0, 0, 0,	"xyu",	NULL,	L"",		L"",		L"" },
	{ 0, 0, 0,	"xye",	NULL,	L"",		L"F",		L"" },
	{ 0, 0, 0,	"xyo",	NULL,	L"",		L"",		L"" },
#endif

	// 
	{ 0, 0, 0,	"bb",	"b",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"cc",	"c",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"dd",	"d",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"ff",	"f",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"gg",	"g",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"hh",	"h",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"jj",	"j",	L"",		L"b",		L"" },
#ifdef SKK_FUNDAMENTALISM
	{ 0, 0, 0,	"kk",	"k",	L"",		L"b",		L"" },
#else
	{ 0, 0, 0,	"kka",	NULL,	L"",	L"bJ",	L"" },
	{ 0, 0, 0,	"kki",	NULL,	L"",	L"bL",	L"" },
	{ 0, 0, 0,	"kku",	NULL,	L"",	L"bN",	L"" },
	{ 0, 0, 0,	"kke",	NULL,	L"",	L"bP",	L"" },
	{ 0, 0, 0,	"kko",	NULL,	L"",	L"bR",	L"" },

	{ 0, 0, 0,	"kkya", NULL,	L"",	L"bL",	L"" },
	{ 0, 0, 0,	"kkyi", NULL,	L"",	L"bLB",	L"" },	// a  
	{ 0, 0, 0,	"kkyu", NULL,	L"",	L"bL",	L"" },
	{ 0, 0, 0,	"kkye", NULL,	L"",	L"bLF",	L"" },	// a  
	{ 0, 0, 0,	"kkyo", NULL,	L"",	L"bL",	L"" },
#endif
	{ 0, 0, 0,	"mm",	"m",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"pp",	"p",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"rr",	"r",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"ss",	"s",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"tt",	"t",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"vv",	"v",	L"",		L"b",		L"" },
#ifdef SKK_FUNDAMENTALISM
	{ 0, 0, 0,	"ww",	"w",	L"",		L"b",		L"" },
#else
	{ 0, 0, 0,	"wwa",	NULL,	L"",	L"b",	L"" },
	{ 0, 0, 0,	"wwi",	NULL,	L"",	L"bEB",	L"" },
	{ 0, 0, 0,	"wwu",	NULL,	L"",	L"bE",	L"" },
	{ 0, 0, 0,	"wwe",	NULL,	L"",	L"bEF",	L"" },
	{ 0, 0, 0,	"wwo",	NULL,	L"",	L"b",	L"" },
#endif
#ifdef SKK_FUNDAMENTALISM
	{ 0, 0, 0,	"xx",	"x",	L"",		L"b",		L"" },
#else
	{ 0, 0, 0,	"xx",	NULL,	L"",		L"b",		L"" },		// [_Xɑ
#endif
	{ 0, 0, 0,	"yy",	"y",	L"",		L"b",		L"" },
	{ 0, 0, 0,	"zz",	"z",	L"",		L"b",		L"" },

	// X (ꕔ̒܂)
	{ 0, 0, 0,	"bya",	NULL,	L"т",	L"r",	L"ެ" },
	{ 0, 0, 0,	"byi",	NULL,	L"т",	L"rB",	L"ި" },	// a  
	{ 0, 0, 0,	"byu",	NULL,	L"т",	L"r",	L"ޭ" },
	{ 0, 0, 0,	"bye",	NULL,	L"т",	L"rF",	L"ު" },	// a  (΂)
	{ 0, 0, 0,	"byo",	NULL,	L"т",	L"r",	L"ޮ" },

#ifndef SKK_FUNDAMENTALISM
	{ 0, 0, 0,	"ca",	NULL,	L"",		L"J",		L"" },
	{ 0, 0, 0,	"ci",	NULL,	L"",		L"V",		L"" },
	{ 0, 0, 0,	"cu",	NULL,	L"",	L"L",	L"" },
	{ 0, 0, 0,	"ce",	NULL,	L"",		L"Z",		L"" },
	{ 0, 0, 0,	"co",	NULL,	L"",		L"R",		L"" },
#endif

	{ 0, 0, 0,	"cha",	NULL,	L"",	L"`",	L"" },
	{ 0, 0, 0,	"chi",	NULL,	L"",		L"`",		L"" },
	{ 0, 0, 0,	"chu",	NULL,	L"",	L"`",	L"" },
	{ 0, 0, 0,	"che",	NULL,	L"",	L"`F",	L"" },
	{ 0, 0, 0,	"cho",	NULL,	L"",	L"`",	L"" },

	{ 0, 0, 0,	"cya",	NULL,	L"",	L"`",	L"" },
	{ 0, 0, 0,	"cyi",	NULL,	L"",	L"`B",	L"" },	// a  
	{ 0, 0, 0,	"cyu",	NULL,	L"",	L"`",	L"" },	// a  
	{ 0, 0, 0,	"cye",	NULL,	L"",	L"`F",	L"" },	// a  
	{ 0, 0, 0,	"cyo",	NULL,	L"",	L"`",	L"" },	// a  

	{ 0, 0, 0,	"dha",	NULL,	L"ł",	L"f",	L"ެ" },	// a  
	{ 0, 0, 0,	"dhi",	NULL,	L"ł",	L"fB",	L"ި" },
	{ 0, 0, 0,	"dhu",	NULL,	L"ł",	L"f",	L"ޭ" },
	{ 0, 0, 0,	"dhe",	NULL,	L"ł",	L"fF",	L"ު" },	// a  
	{ 0, 0, 0,	"dho",	NULL,	L"ł",	L"f",	L"ޮ" },	// a  

	{ 0, 0, 0,	"dya",	NULL,	L"",	L"a",	L"ެ" },
	{ 0, 0, 0,	"dyi",	NULL,	L"",	L"aB",	L"ި" },	// a  
	{ 0, 0, 0,	"dyu",	NULL,	L"",	L"a",	L"ޭ" },
	{ 0, 0, 0,	"dye",	NULL,	L"",	L"aF",	L"ު" },
	{ 0, 0, 0,	"dyo",	NULL,	L"",	L"a",	L"ޮ" },

	{ 0, 0, 0,	"fa",	NULL,	L"ӂ",	L"t@",	L"̧" },
	{ 0, 0, 0,	"fi",	NULL,	L"ӂ",	L"tB",	L"̨" },
	{ 0, 0, 0,	"fu",	NULL,	L"",		L"t",		L"" },
	{ 0, 0, 0,	"fe",	NULL,	L"ӂ",	L"tF",	L"̪" },
	{ 0, 0, 0,	"fo",	NULL,	L"ӂ",	L"tH",	L"̫" },

	{ 0, 0, 0,	"fya",	NULL,	L"ӂ",	L"t",	L"̬" },	// a  Ђ
	{ 0, 0, 0,	"fyi",	NULL,	L"ӂ",	L"tB",	L"̨" },
	{ 0, 0, 0,	"fyu",	NULL,	L"ӂ",	L"t",	L"̭" },
	{ 0, 0, 0,	"fye",	NULL,	L"ӂ",	L"tF",	L"̪" },
	{ 0, 0, 0,	"fyo",	NULL,	L"ӂ",	L"t",	L"̮" },	// a  Ђ

	{ 0, 0, 0,	"gya",	NULL,	L"",	L"M",	L"ެ" },
	{ 0, 0, 0,	"gyi",	NULL,	L"",	L"MB",	L"ި" },	// a  
	{ 0, 0, 0,	"gyu",	NULL,	L"",	L"M",	L"ޭ" },
	{ 0, 0, 0,	"gye",	NULL,	L"",	L"MF",	L"ު" },	// a  
	{ 0, 0, 0,	"gyo",	NULL,	L"",	L"M",	L"ޮ" },

	{ 0, 0, 0,	"hya",	NULL,	L"Ђ",	L"q",	L"ˬ" },
	{ 0, 0, 0,	"hyi",	NULL,	L"Ђ",	L"qB",	L"˨" },	// a  
	{ 0, 0, 0,	"hyu",	NULL,	L"Ђ",	L"q",	L"˭" },
	{ 0, 0, 0,	"hye",	NULL,	L"Ђ",	L"qF",	L"˪" },	// a  
	{ 0, 0, 0,	"hyo",	NULL,	L"Ђ",	L"q",	L"ˮ" },

	{ 0, 0, 0,	"ja",	NULL,	L"",	L"W",	L"ެ" },
	{ 0, 0, 0,	"ji",	NULL,	L"",		L"W",		L"" },
	{ 0, 0, 0,	"ju",	NULL,	L"",	L"W",	L"ޭ" },
	{ 0, 0, 0,	"je",	NULL,	L"",	L"WF",	L"ު" },
	{ 0, 0, 0,	"jo",	NULL,	L"",	L"W",	L"ޮ" },

	{ 0, 0, 0,	"jya",	NULL,	L"",	L"W",	L"ެ" },
	{ 0, 0, 0,	"jyi",	NULL,	L"",	L"WB",	L"ި" },	// a  
	{ 0, 0, 0,	"jyu",	NULL,	L"",	L"W",	L"ޭ" },
	{ 0, 0, 0,	"jye",	NULL,	L"",	L"WF",	L"ު" },
	{ 0, 0, 0,	"jyo",	NULL,	L"",	L"W",	L"ޮ" },

	{ 0, 0, 0,	"kya",	NULL,	L"",	L"L",	L"" },
	{ 0, 0, 0,	"kyi",	NULL,	L"",	L"LB",	L"" },	// a  
	{ 0, 0, 0,	"kyu",	NULL,	L"",	L"L",	L"" },
	{ 0, 0, 0,	"kye",	NULL,	L"",	L"LF",	L"" },	// a  
	{ 0, 0, 0,	"kyo",	NULL,	L"",	L"L",	L"" },

	{ 0, 0, 0,	"mya",	NULL,	L"݂",	L"~",	L"Ь" },
	{ 0, 0, 0,	"myi",	NULL,	L"݂",	L"~B",	L"Ш" },	// a  
	{ 0, 0, 0,	"myu",	NULL,	L"݂",	L"~",	L"Э" },
	{ 0, 0, 0,	"mye",	NULL,	L"݂",	L"~F",	L"Ъ" },	// Ȉa
	{ 0, 0, 0,	"myo",	NULL,	L"݂",	L"~",	L"Ю" },

	{ 0, 0, 0,	"nya",	NULL,	L"ɂ",	L"j",	L"Ƭ" },
	{ 0, 0, 0,	"nyi",	NULL,	L"ɂ",	L"jB",	L"ƨ" },	// a  
	{ 0, 0, 0,	"nyu",	NULL,	L"ɂ",	L"j",	L"ƭ" },
	{ 0, 0, 0,	"nye",	NULL,	L"ɂ",	L"jF",	L"ƪ" },	// Ȉa
	{ 0, 0, 0,	"nyo",	NULL,	L"ɂ",	L"j",	L"Ʈ" },

	{ 0, 0, 0,	"pya",	NULL,	L"҂",	L"s",	L"߬" },
	{ 0, 0, 0,	"pyi",	NULL,	L"҂",	L"sB",	L"ߨ" },	// a  
	{ 0, 0, 0,	"pyu",	NULL,	L"҂",	L"s",	L"߭" },
	{ 0, 0, 0,	"pye",	NULL,	L"҂",	L"sF",	L"ߪ" },	// Ȉa
	{ 0, 0, 0,	"pyo",	NULL,	L"҂",	L"s",	L"߮" },

	{ 0, 0, 0,	"rya",	NULL,	L"",	L"",	L"ج" },
	{ 0, 0, 0,	"ryi",	NULL,	L"股",	L"B",	L"ب" },	// a  
	{ 0, 0, 0,	"ryu",	NULL,	L"",	L"",	L"ح" },
	{ 0, 0, 0,	"rye",	NULL,	L"肥",	L"F",	L"ت" },	// Ȉa
	{ 0, 0, 0,	"ryo",	NULL,	L"",	L"",	L"خ" },

	{ 0, 0, 0,	"sha",	NULL,	L"",	L"V",	L"" },
	{ 0, 0, 0,	"shi",	NULL,	L"",		L"V",		L"" },
	{ 0, 0, 0,	"shu",	NULL,	L"",	L"V",	L"" },
	{ 0, 0, 0,	"she",	NULL,	L"",	L"VF",	L"" },
	{ 0, 0, 0,	"sho",	NULL,	L"",	L"V",	L"" },

	{ 0, 0, 0,	"sya",	NULL,	L"",	L"V",	L"" },
	{ 0, 0, 0,	"syi",	NULL,	L"",	L"VB",	L"" },	// a  
	{ 0, 0, 0,	"syu",	NULL,	L"",	L"V",	L"" },
	{ 0, 0, 0,	"sye",	NULL,	L"",	L"VF",	L"" },
	{ 0, 0, 0,	"syo",	NULL,	L"",	L"V",	L"" },

#ifdef SKK_FUNDAMENTALISM
	{ 0, 0, 0,	"tsu",	NULL,	L"",		L"c",		L"" },
#else
	{ 0, 0, 0,	"tsa",	NULL,	L"",	L"c@",	L"§" },
	{ 0, 0, 0,	"tsi",	NULL,	L"",	L"cB",	L"¨" },
	{ 0, 0, 0,	"tsu",	NULL,	L"",		L"c",		L"" },
	{ 0, 0, 0,	"tse",	NULL,	L"",	L"cF",	L"ª" },
	{ 0, 0, 0,	"tso",	NULL,	L"",	L"cH",	L"«" },
#endif

#ifdef SKK_FUNDAMENTALISM_STRICT
	{ 0, 0, 0,	"tha",	NULL,	L"Ă",	L"e@",	L"ç" },	// sR ̃oOH
#else
	{ 0, 0, 0,	"tha",	NULL,	L"Ă",	L"e",	L"ì" },	// a  
#endif
	{ 0, 0, 0,	"thi",	NULL,	L"Ă",	L"eB",	L"è" },
	{ 0, 0, 0,	"thu",	NULL,	L"Ă",	L"e",	L"í" },
	{ 0, 0, 0,	"the",	NULL,	L"Ă",	L"eF",	L"ê" },	// a  ()
	{ 0, 0, 0,	"tho",	NULL,	L"Ă",	L"e",	L"î" },

	{ 0, 0, 0,	"tya",	NULL,	L"",	L"`",	L"" },
	{ 0, 0, 0,	"tyi",	NULL,	L"",	L"`B",	L"" },	// a  
	{ 0, 0, 0,	"tyu",	NULL,	L"",	L"`",	L"" },
	{ 0, 0, 0,	"tye",	NULL,	L"",	L"`F",	L"" },
	{ 0, 0, 0,	"tyo",	NULL,	L"",	L"`",	L"" },

	{ 0, 0, 0,	"va",	NULL,	L"J",	L"@",	L"ާ" },
	{ 0, 0, 0,	"vi",	NULL,	L"J",	L"B",	L"ި" },
	{ 0, 0, 0,	"vu",	NULL,	L"J",	L"",		L"" },
	{ 0, 0, 0,	"ve",	NULL,	L"J",	L"F",	L"ު" },
	{ 0, 0, 0,	"vo",	NULL,	L"J",	L"H",	L"ޫ" },

#ifndef SKK_FUNDAMENTALISM
	// sRȕ\LOEa΍ƂēĂ
	{ 0, 0, 0,	"vya",	NULL,	L"J",	L"",	L"ެ" },	// ő  т
	{ 0, 0, 0,	"vyi",	NULL,	L"J",	L"B",	L"ި" },
	{ 0, 0, 0,	"vyu",	NULL,	L"J",	L"",	L"ޭ" },	// ő  т
	{ 0, 0, 0,	"vye",	NULL,	L"J",	L"F",	L"ު" },
	{ 0, 0, 0,	"vyo",	NULL,	L"J",	L"",	L"ޮ" },	// ő  т
#endif

	{ 0, 0, 0,	"zya",	NULL,	L"",	L"W",	L"ެ" },
	{ 0, 0, 0,	"zyi",	NULL,	L"",	L"WB",	L"ި" },	// a  
	{ 0, 0, 0,	"zyu",	NULL,	L"",	L"W",	L"ޭ" },
	{ 0, 0, 0,	"zye",	NULL,	L"",	L"WF",	L"ު" },
	{ 0, 0, 0,	"zyo",	NULL,	L"",	L"W",	L"ޮ" },

#ifndef SKK_FUNDAMENTALISM
	// sRȕ\LG΍ƂēĂ
	{ 0, 2, 0,	"kkk",	NULL,	L"",	NULL,		L"kkk" },	// (ok)̘A
	{ 0, 2, 0,	"www",	NULL,	L"",	NULL,		L"www" },	// (warai)̘A
	// ukwa ()vȂǂ̌ÂKvȏꍇ͂ɒǉ[Kv
#endif

	// Lϊ[
#ifdef SKK_FUNDAMENTALISM
	{ 0, 0, 0,	"-",	NULL,	L"[",	NULL,	L"" },
	{ 0, 0, 0,	";",	NULL,	L"G",	NULL,	NULL },
	{ 0, 0, 0,	":",	NULL,	L"F",	NULL,	NULL },
	{ 0, 0, 0,	"?",	NULL,	L"H",	NULL,	NULL },
	{ 0, 0, 0,	"[",	NULL,	L"u",	NULL,	L"" },
	{ 0, 0, 0,	"]",	NULL,	L"v",	NULL,	L"" },

	{ 0, 0, 0,	"z/",	NULL,	L"E",	NULL,	L"" },
	{ 0, 0, 0,	"z,",	NULL,	L"d",	NULL,	NULL },
	{ 0, 0, 0,	"z.",	NULL,	L"c",	NULL,	NULL },
	{ 0, 0, 0,	"z-",	NULL,	L"`",	NULL,	NULL },
	{ 0, 0, 0,	"z[",	NULL,	L"w",	NULL,	NULL },
	{ 0, 0, 0,	"z]",	NULL,	L"x",	NULL,	NULL },

	{ 0, 0, 0,	"zh",	NULL,	L"",	NULL,	NULL },
	{ 0, 0, 0,	"zj",	NULL,	L"",	NULL,	NULL },
	{ 0, 0, 0,	"zk",	NULL,	L"",	NULL,	NULL },
	{ 0, 0, 0,	"zl",	NULL,	L"",	NULL,	NULL },
#else
	{ 0, 0, 0,	"-",	NULL,	L"[",	NULL,	L"" },
	{ 0, 0, 0,	"~",	NULL,	L"`",	NULL,	NULL },
//	{ 0, 0, 0,	";",	NULL,	L"G",	NULL,	NULL },		// C
//	{ 0, 0, 0,	":",	NULL,	L"F",	NULL,	NULL },		// C
	{ 0, 0, 0,	"!",	NULL,	L"I",	NULL,	NULL },
	{ 0, 0, 0,	"?",	NULL,	L"H",	NULL,	NULL },
	{ 0, 0, 0,	"[",	NULL,	L"u",	NULL,	L"" },
	{ 0, 0, 0,	"]",	NULL,	L"v",	NULL,	L"" },
	{ 0, 0, 0,	"{",	NULL,	L"w",	NULL,	NULL },
	{ 0, 0, 0,	"}",	NULL,	L"x",	NULL,	NULL },

	#define RULE(roma, out, kana)\
	{ 0, 0, 0, "z" ## roma, NULL, out, NULL, kana },\
	{ 0, 0, 0, "x" ## roma, NULL, out, NULL, kana },\
	{ 0, 0, 0, "f" ## roma, NULL, out, NULL, kana },\
	{ 0, 0, 0, "j" ## roma, NULL, out, NULL, kana }
	RULE(" ",	L"@",	NULL),	// [_Xȋ󔒂̎gdv (SHIFT+SPACEp̕~)
	RULE("1",	L"",	NULL),
	RULE("2",	L"",	NULL),
	RULE("3",	L"",	NULL),
	RULE("4",	L"",	NULL),
	RULE("5",	L"",	NULL),
	RULE("6",	L"",	NULL),
	RULE("7",	L"",	NULL),	// C
	RULE("8",	L"k",	NULL),
	RULE("9",	L"l",	NULL),
	RULE("0",	L"",	NULL),
	RULE("-",	L"`",	NULL),
	RULE("^",	L"",	NULL),
	RULE("\\\\",	L"",	NULL),
	RULE("@",	L"V",	NULL),
	RULE("[",	L"w",	NULL),	// C
	RULE("]",	L"x",	NULL),	// C
	RULE(";",	L"J",	L""),
	RULE(":",	L"K",	L""),
	RULE(",",	L"d",	NULL),
	RULE(".",	L"c",	NULL),
	RULE("/",	L"E",	L""),
	RULE("!",	L"",	NULL),
	RULE("\"",	L"",	NULL),
	RULE("#",	L"",	NULL),
	RULE("$",	L"",	NULL),
	RULE("%",	L"",	NULL),
	RULE("&",	L"",	NULL),
	RULE("'",	L"",	NULL),	// C
	RULE("(",	L"y",	NULL),
	RULE(")",	L"z",	NULL),
	RULE("=",	L"",	NULL),
	RULE("~",	L"",	NULL),
	RULE("|",	L"",	NULL),
	RULE("`",	L"g",	NULL),	// C
	RULE("{",	L"",	NULL),	// C
	RULE("}",	L"",	NULL),	// C
	RULE("+",	L"}",	NULL),
	RULE("*",	L"~",	NULL),
	RULE("<",	L"",	NULL),
	RULE(">",	L"",	NULL),
	RULE("?",	L"",	NULL),
	RULE("_",	L"\",	NULL),
	#undef RULE

	#define RULE(roma, out, kana)\
	{ 0, 0, 0, "z" ## roma, NULL, out, NULL, kana },\
	{ 0, 0, 0, "f" ## roma, NULL, out, NULL, kana }
	RULE("h",	L"",	NULL),
	RULE("j",	L"",	NULL),
	RULE("k",	L"",	NULL),
	RULE("l",	L"",	NULL),
	#undef RULE
#endif

	// Ǔ_
	// ݂͊ȈՎ ( skk-current-touten JIS X0201[hFĈ{)
	{ 0, 0, NFUNC_SKK_CURRENT_TOUTEN,			",",	NULL,	NULL,	NULL,	(LPCWSTR)1 },
	{ 0, 0, NFUNC_SKK_CURRENT_KUTEN,			".",	NULL,	NULL,	NULL,	(LPCWSTR)1 },
	{ 0, 0, 0,									",",	NULL,	NULL,	NULL,	L"" },
	{ 0, 0, 0,									".",	NULL,	NULL,	NULL,	L"" },

	// SKK֐
	{ 0, 0, NFUNC_SKK_LATIN_MODE,				"l",	NULL,	NULL,	NULL,	NULL },
	{ 0, 0, NFUNC_SKK_JISX0208_LATIN_MODE,		"L",	NULL,	NULL,	NULL,	NULL },
	{ 0, 0, NFUNC_SKK_TOGGLE_CHARACTERS,		"q",	NULL,	NULL,	NULL,	NULL },
	{ 0, 0, NFUNC_SKK_SET_HENKAN_POINT_SUBR,	"Q",	NULL,	NULL,	NULL,	NULL },
	{ 0, 0, NFUNC_SKK_PURGE_FROM_JISYO,			"X",	NULL,	NULL,	NULL,	NULL },
	{ 0, 0, NFUNC_SKK_ABBREV_MODE,				"/",	NULL,	NULL,	NULL,	NULL },	// C

#ifdef SKK_FUNDAMENTALISM
	{ 0, 0, NFUNC_SKK_TODAY,					"@",	NULL,	NULL,	NULL,	NULL },
	{ 0, 0, NFUNC_SKK_INPUT_BY_CODE_OR_MENU,	"\\\\",	NULL,	NULL,	NULL,	NULL },
	// { 0, 0, NFUNC_SKK_DISPLAY_CODE_FOR_CHAR_AT_POINT,	"$",	NULL,	NULL,	NULL,	NULL },
#else
	// ppxɒ[ɒႢ(̂̕قpxyɍ)R}h2Xg[NɕύX
	// skk-today ͂g悤ɂȂɔĎcĂ
	// skk-display-code(ry IME̊O̐EŎgȂΈӖƎvȂ̂ō폜
	{ 0, 0, NFUNC_SKK_TODAY,					"c@",	NULL,	NULL,	NULL,	NULL },
	// { 0, 0, NFUNC_SKK_ABBREV_MODE,				"c/",	NULL,	NULL,	NULL,	NULL },
	{ 0, 0, NFUNC_SKK_INPUT_BY_CODE_OR_MENU,	"c\\\\",	NULL,	NULL,	NULL,	NULL },
	// { 0, 0, NFUNC_SKK_DISPLAY_CODE_FOR_CHAR_AT_POINT,	"c$",	NULL,	NULL,	NULL,	NULL },
#endif

#if 0
	// L[}bvgׂł͂Ȃ낤
	{ 0, 0, NFUNC_SKK_KAKUTEI,					"\r",	NULL,	NULL,	NULL,	NULL },
#endif

	// 1: ohϊp[
	{ 1, 0, 0,	"hh",	"h\\I",	L"",	NULL,	L"" },	// (o^͖֌W)̏Ŕ
	{ 1, 0, 0,	"h\\V",	"h\\I",	L"",	NULL,	L"" },
	{ 1, 0, 0,	"h\\?",	"\\I",	L"",	L"I",	L"" },
	{ 1, 0, 0,	"\\?",	"\\I",	L"",	NULL,	L"" },

	// 2: k/wϊp[
	{ 2, 2, 0,	"k",	NULL,	L"",	NULL,	L"k" },
	{ 2, 2, 0,	"w",	NULL,	L"",	NULL,	L"w" },
	{ 2, 0, 0,	"\\?",	"\\I",	L"",	NULL,	L"" },
};
