/*	config.cpp
 *
 *	ITfFnConfigure implementation
 */
#include "globals.h"
// #include <shlwapi.h>
#include "skimic.h"
#include "skkimmgr.h"
#include "IME/ImeConfig.h"

//	䂾B
#define	DISPLAYNAME_DESC	_T("SKKIME1.5(Disp)")

#include "../common/modulepath.h"

HRESULT
CSkkImeTextService::Show (
	HWND		hwndParent,
	LANGID		langid,
	REFGUID		rguidProfile)
{
	/*	Secure Session Ȃ Config ͎sĂ͂ȂȂB*/
#if defined (__ITfTextInputProcessorEx_INTERFACE_DEFINED__)
	if (m_dwActivateFlag & TF_TMAE_SECUREMODE)
		return	E_FAIL ;
#endif
	if (langid != SKKIME_LANGID)
		return	E_FAIL ;

	TCHAR rszWindowsDir[MAX_PATH];
	UINT n = GetWindowsDirectory(rszWindowsDir, countof(rszWindowsDir));
	ASSERT(n && n < countof(rszWindowsDir));
	TCHAR rszCmd[MAX_PATH];
	_tcscpy_s(rszCmd, countof(rszCmd), rszWindowsDir);
	_tcscpy_s(rszCmd + n, countof(rszCmd) - n, SKKIME_APPLET_USERINTERFACE);

	/*	 pipename n\ɖ߂Ă݂B(PTNVQS())
	 *	Windows2000sp4  skkiserv  connect s錻ۂ̂ŁB
	 *	͂̏낤H
	 *	̂ skkiserv  pipename ɍĂƗ\zĂ鎞
	 *	if (! CreateProcessW (rszCmd, L"", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi)) {
	 *	B
	 */
	STARTUPINFO si;
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	PROCESS_INFORMATION pi;
	if (!CreateProcess(rszCmd, _T(""), NULL, NULL, FALSE, 0, NULL, rszWindowsDir, &si, &pi))
		return E_FAIL;

	/* svɂȂnhB*/
	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

	return	S_OK ;

	UNREFERENCED_PARAMETER (hwndParent) ;
	UNREFERENCED_PARAMETER (rguidProfile) ;
}

STDAPI
CSkkImeTextService::GetDisplayName (
	BSTR*			pbstrName)
{
	if (pbstrName == NULL)
		return	E_INVALIDARG ;

	*pbstrName	= SysAllocString (DISPLAYNAME_DESC) ;
	return	(*pbstrName == NULL)? E_OUTOFMEMORY : S_OK ;
}

BOOL
CSkkImeTextService::_InitConfig ()
{
	if (m_pConfig == NULL)
		m_pConfig	= CImeConfig::pCreateInstance () ;
	if (m_pConfig == NULL)
		return	FALSE ;
	m_pConfig->vUpdate () ;
	return	TRUE ;
}

