#pragma once

/// @todo dchar.h ͎QƉ񐔂ɎQƊ֌WŒꒃȂ̂ globals.h ɓ

typedef DWORD DCHAR ;

typedef DCHAR*			LPDSTR ;
typedef const DCHAR*	LPCDSTR ;

#define	GET_UNICODE_PLANE(ch)	((ch) >> 16)
#define	GET_UNICODE_CODE(ch)	((ch) & 0xFFFF)
#define	MAKE_DCHAR(plane,code)	(((DWORD)(plane) << 16) | (DWORD)(code))

#define	MAKE_DCHAR_FROM_SURROGATE_PAIR(dwHigh,dwLow)	(((((DWORD)(dwHigh) - 0xD800UL) << 10) | ((DWORD)(dwLow) - 0xDC00UL)) + 0x10000UL)
#define	GET_HIGHSURROGATE_FROM_DCHAR(dwD)	((WCHAR)(0xD800 + ((((dwD) - 0x10000UL) >> 10) & 0x3FF)))
#define	GET_LOWSURROGATE_FROM_DCHAR(dwD)	((WCHAR)(0xDC00 + (((dwD) - 0x10000UL) & 0x3FF)))

#ifndef IS_HIGH_SURROGATE
#define	IS_HIGH_SURROGATE(n1)		(0xD800 <= (n1) && (n1) < 0xDC00)
#endif
#ifndef IS_LOW_SURROGATE
#define	IS_LOW_SURROGATE(n2)		(0xDC00 <= (n2) && (n2) < 0xE000)
#endif
#ifndef IS_SURROGATE_PAIR
#define	IS_SURROGATE_PAIR(n1,n2)	(IS_HIGH_SURROGATE((n1)) && IS_LOW_SURROGATE((n2)))
#endif
#if !defined (WINVER) || WINVER < 0x0600
typedef enum _NORM_FORM {
    NormalizationOther  = 0,
    NormalizationC      = 0x1,
    NormalizationD      = 0x2,
    NormalizationKC     = 0x5,
	NormalizationKD     = 0x6,
} NORM_FORM;
#endif

#define	isdalnum(ch)			(GET_UNICODE_PLANE((ch)) == 0 && iswalnum((WCHAR)(ch)))

#if 1

DWORD	todupper (DCHAR ch) ;
DWORD	todlower (DCHAR ch) ;
BOOL	isdspace (DCHAR ch) ;
int	dcsncmp (LPCDSTR, LPCDSTR, int) ;
int dcsnicmp (LPCDSTR, LPCDSTR, int) ;
int	dcslen (LPCDSTR) ;
int	dcscpy (LPDSTR, LPCDSTR) ;
int	dcsncpy (LPDSTR, LPCDSTR, int) ;
int	wcstodcs (LPDSTR pDest, int nDestSize, LPCWSTR pSrc, int nSrcLen) ;
int	dcstowcs (LPWSTR pDest, int nDestSize, LPCDSTR pSrc, int nSrcLen) ;
int	wcstodcs_n (LPDSTR pDest, int nDestSize, LPCWSTR pSrc, int nSrcLen) ;	// with normalize_C

typedef unsigned int sizet;
sizet dcsnlen (LPCDSTR, sizet) ;

#else

/// @note  UTF-32 ͋ǏIɌ115rbgx̏ʂȂ߁A{ɂ̌`ŕKv̂ǂ^B̗ǂ UTF-16 Ƃ̊ԂŉxRs[ȂgKv̂ǂׂBUnicode Web Traversal΍̂߂Ȃʂ̎iɊׂB
/// @note ʓI Windows XP ɂ Normaliz.dll Ȃ̂ wcstodcs_n ̐K͍pĂȂBUAX #154ނ̐KKv邩ȂB

// ^`
typedef unsigned int sizet;	///< x64 size_t ͕svAKvɉĒuւ\Ȍ𖾎
typedef BOOL boolt;			///< bool (32rbg2)ɒu\Ȍ𖾎(3Ԃ㩂)
typedef WCHAR wchar;		///< char n͏ŏƂdlBd char
typedef DCHAR dchar;

////////////////////////////////////////////////////////////////////

/// dchar 啶
dchar todupper(dchar c);

/// dchar 
dchar todlower(dchar c);

/// dchar R[h̋󔒕
boolt isdspace(dchar c);

////////////////////////////////////////////////////////////////////

/// dchar 𒲂ׂ
sizet dcsnlen(const dchar* p, sizet n);

/// dchar ̔r
int dcsncmp(const dchar* p1, const dchar* p2, sizet n);

/// dchar ̔r (p啶ʂȂ)
int dcsnicmp(const dchar* p1, const dchar* p2, sizet n);

/// dchar ̃Rs[
void dcscpy_s(dchar* pDst, sizet n, const dchar* pSrc);

////////////////////////////////////////////////////////////////////

/// wchar 񂩂 dchar ւ̕ϊ
sizet wcstodcs(dchar* pDst, sizet nDst, const wchar* pSrc, sizet nSrc);

/// dchar 񂩂 wchar ւ̕ϊ
sizet dcstowcs(wchar* pDst, sizet nDst, const dchar* pSrc, sizet nSrc);

////////////////////////////////////////////////////////////////////

/// dchar 𒲂ׂ (ő4096܂)
sizet dcslenX(const dchar* p);
/// dchar 𒲂ׂ (ő4096܂) @see dcslenX
#define dcslen dcslenX

/// dchar ̃Rs[ (ő4096܂)
void dcscpyX(dchar* pDst, const dchar* pSrc);
/// dchar ̃Rs[ (ő4096܂) @see dcscpyX
#define dcscpy dcscpyX

/// dchar CӃTCỸ̕Rs[ @see dcscpy_s
#define dcsncpy(d, s, n) dcscpy_s(d, n, s)

/// wchar 񂩂 dchar ւ̕ϊ (ODLLɂ鐳K͍sȂȂ) @see wcstodcs
#define wcstodcs_n wcstodcs

////////////////////////////////////////////////////////////////////

#endif
